/* HELL01.C    HELL ZENDEN EN ONTVANGEN */
/* 21-03-2000 begonnen */
/* 08-04-2000 version with storage reception data */
/* 09-04-2000 small changes */
/* 12-04-2000 skip pixels when replay mode (F1...F4) */
/* 21-04-2000 Grey scale adjustments + replay mods */
/* 11-05-2000 Tekst display iets gewijzigd */
/* 26-05-2000 HRX file als binary bestand openen */
/* 11-05-2001 Tekst enigzins aangepast */

/* O.H. Hoekstra */

#include <IO.H>
#include <STDIO.H>
#include <CONIO.H>
#include <DOS.H>
#include <GRAPH.H>
#include <MATH.H>
#include <STRING.H>
#include <TIME.H>
#include <SYS\TYPES.H>
#include <SYS\TIMEB.H>

#pragma check_stack (off)

#define MINPLAATS 3
#define BEGINREGEL 2
#define MAXREGEL 44
#define INPUTPLAATS 8
#define MAXINPUT 68
#define MAXTEKST 76
#define DTABIT 0x20
#define PPIXELS 200

void (_interrupt _far *Oldclock) (void);
static void _interrupt _far TXport (void);
void Menu_A(void);
void Uitleg(void);

void Mainloop(void);
void InsNewclock(void);
void InsOldclock(void);
void Fillcolor_regs(void);
void Fillgrey_array(void);
int Poortstatus(void);
void New_character(void);
void Newdisplay(void);
void Helldisplay(void);
int INport(void);
void Setport(int);
void Msgkar(void);
void RXfile_handle(void);
void Get_settings(void);
void Store_settings(void);
void Replay_hrx(void);
void Replayskip(long int n);
void Fixlengte(char *da, char k, int le);
void Kloktijd(void);
int Klokhexdec(int hex);
int Klokdechex(int dec);

void Hline(int r1, int c1, int c2);
void In_ntext(int yp,int xp,int maxlen,char *k);
void In_utext(int yp,int xp,int maxlen,char *k);

void inkey();
void Print(int, int, char *);
void Scherm(int);
void pauze(float);
void Vline(int r1, int c1, int r2);
void window(int,int,int,int);

FILE *MSGfile;
FILE *RXfile;
FILE *REPLAYfile;

int tekstkleur;
int schermkleur;
int keyvalue;

int SCRN_green=0;
int SCRN_blue=32;
int SCRN_red=0;

int TEXT_green=32;
int TEXT_blue=32;
int TEXT_red=32;

int Lijn0;
int Lijn1;
int Lijn2;
int Lijn3;
int Lijn4;
int Lijn5;
int Lijn6;

int TESTVALUE=0;
int POORT=0;            /* status teken aan/uit */
int Regel=BEGINREGEL;
int Plaats=MINPLAATS;
int TXbuf_plaats=0;     /* karakternr.  dat wordt verzonden */
int Tekstbuf_plaats=0;  /* karakternr.  dat van keyboard wordt gelezen */
int Hellchar;           /* Hellcharacter transmitted */
int Replay=0;           /* 0=Hell TX/RX, 1=Replay */
int Clear_cursor=0;
int Store_text=0;       /* 1 indien store in keyer.txt */
int Update_screen;
int Dpuls;
int Dble_width=0;       /* transmit with double width */
int Dble_widthcnt=0;    /* Dble_width counter */
int Extra_res=0;        /* 1 for extra horizontal resolution */
int TKstatus=0;         /* 1 teken TX 2 .- spatie TX 0 gereed voor volgende */
int Detector=1;         /* 0=comparator 1=D/A converter */
int TX_on=0;            /* 0=HellRX, 1=HellTX, 2=CWTX */
int NewTX_on=0;         /* 0=HellRX, 1=HellTX, 2=CWTX */
int TXRXstate=0;        /* if TX: 0=RX off 1=PC data 2=RX on */
int Scale = 0;          /* Grey Scale selection for display */
int LPT;
int LPT1;               /* 98765432 pin LPT */
int RXport=249;         /* 11111001 voor RX */
int TXport_stby=245;    /* 11110101 voor TX stby */
int TXport_tone=246;    /* 11110110 voor TX tone */

float MS=1.6326;        /* interrupt per 1.6326 ms */
float Symbolrate=8.163; /* symbolrate 8.163 ms voor Feldhell */
int Resolution=2;       /* min. 1 max 4 */
int Pixels=4;           /* Pixels per symbol */
int Halfpixels=2;       /* Helft pixels */
int Mode_change=1;      /* 1 als er een change van TX-RX of RX-TX is */
int Input_count=0;      /* telt aantal inputkarakters in buffer */
int Tekst_count=0;      /* counter voor Tekstbuf */
int keypress=1;         /* 1 indien tenminste 1 karakter is verzonden */
int Tune_count=0;       /* counter indien Tune geactiveerd */
int Tone_on=0;          /* 1 indien PC-beep voor morse */
int Tone_freq=800;      /* Tone frequency */
int Intrun=0;           /* 1 indien interruptroutine geactiveerd */
int MSGfileopen=0;      /* 1 indien MSG file open */
int RXfileopen=0;       /* 1 indien RX file open */
int New_buffer=1;       /* Nieuwe buffer uitprinten */
int Check_TX=0;         /* controle bij msg of TX aan (F11 en F12) */
int Inv_scrn=0;         /* 1 for invert screen */
int Newpage=0;          /* 1 if goto top of screen */
int Symbolcnt=0;        /* counts symbols */
int Pixelcnt=7;         /* counts pixels */
int Intpls=0;           /* intcounter for wait routines */
int Symbolwidth=5;      /* Symbolwidth */
int Inc_symbolwidth=0;  /* increment / decrement horizontal resolution */
int Row_space=1;        /* row space between Hell lines */
int AD_timeout=365;     /* Timeout value AD convertor 388=4.5 volt*/
int AD_offset=110;      /* AD offset black value 100=1.50 volt*/
int AD_start;           /* AD_start in interrupt routine */
int AD_stop;            /* AD_stop in interrupt routine */

unsigned int Screenmode=0;   /*0=18d, 1=0x101, 2=0x103 of 3=0x105 */
unsigned int Pixeltube[260]; /* storage for pixels read by interruptroutine */
unsigned int Tubecnt=0;      /* Tube Counter for Helldisplay */
unsigned int Tube_intcnt=0;  /* Tube Counter for interruptroutine */
unsigned int PixelrowA1=0;   /* Active upper row in Helldisplay */
unsigned int PixelrowA2=0;   /* Active upper row in Helldisplay */
unsigned int PixelrowB1=0;   /* Active lower row in Helldisplay */
unsigned int PixelrowB2=0;   /* Active lower row in Helldisplay */
unsigned int Pixeloffset;    /* Active offset in Helldisplay row */
unsigned int PixelcolomA1=0; /* Active colom in Helldisplay */
unsigned int PixelcolomA2=0; /* Active colom in Helldisplay */
unsigned int PixelcolomB1=0; /* Active colom in Helldisplay */
unsigned int PixelcolomB2=0; /* Active colom in Helldisplay */
unsigned int Max_row=400;    /* Maximum row */
unsigned int Max_colom=600;  /* Maximum colom */
unsigned int Max_offset;     /* Maximum Pixeloffset */
unsigned int Row_step;       /* Row_step variable */
unsigned int Row_check;      /* Row_check variable */
unsigned int Colom_check;    /* Colom_check variable */
unsigned int Max_change_wres;/* No change of wresolution beyond this */
unsigned int UUR;       /* bevat uurtijd na Kloktijd() */
unsigned int MINUUT;    /* bevat minuuttijd na Kloktijd() */
unsigned int JAAR;      /* enz. */
unsigned int MAAND;
unsigned int DAG;

unsigned int Interrupt_count; /* interrupt counter variabele */

unsigned long Pixelcount=0; /* Pixelcounter */
unsigned long Pixelprint=0; /* Print Pixelcount if Pixelprint = 0 */

unsigned long Puntlng;  /* in interruptcounts van MS ms */
unsigned long Streeplng;/* lengte punt */
unsigned long SPlng;    /* lengte spatie */
unsigned long SPrate=3; /* rate letter spatie t.o.v. punt */

unsigned long Stat_Hchar;     /* characters transmitted */
unsigned long Stat_pixel;     /* pixels transmitted */
unsigned long Stat_pixelon;   /* pixels with TX on */
unsigned long Stat_CWchar;    /* characters transmitted */
unsigned long Stat_CW;        /* CW pings transmitted */
unsigned long Stat_CWon;      /* CW pings with TX on */
int Stat_state=0;             /* 0=no statistics 1 statistics on */

unsigned char Tkvalue=0;         /* waarde van het thans verzonden teken */
unsigned char MORSEkar[260];     /* bevat de morsekarakters */
unsigned char Hellfont[256][44]; /* bevat het hellfont */

float Wpm=16;           /* Words per minute */

int Grey[3][257];       /* Grey scales for display */

char kar[255];          /* algemeen gebruikte array */
char Pbuf[255];
char Displaykar[20];
char Tekstbuf[255];
char Msgnaam[20];       /* Naam van message file */
char RXnaam[20];        /* Naam van RX data */
char REPLAYnaam[30];    /* naam van REPLAYfile */
char KLOK[30];          /* datum - tijd stempel */
char Wisbuffer[80];     /* buffer wissen */
char Wisregel[80];      /* regel wissen */

unsigned char Inputbuf[80];



/****************************************************************************
 *
 * MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN
 *
 ****************************************************************************/
void main (void)
{
int m,n;
tekstkleur=7;
schermkleur=9;  /* 9 voor blauw */

LPT = *(int _far*)0x408;
LPT1 = LPT + 1;

Scherm(25);

sprintf(Pbuf,"LPT1 adres: %xH",LPT);
Print (10,10,Pbuf);

for (n = 0; n < 257; n++)
   MORSEkar[n] = 0; /* 0 for unspecified characters */

MORSEkar[32] = 255; /* special case, space=255 */

MORSEkar[65] = 6;   /* 00000110 A */
MORSEkar[66] = 17;  /* 00010001 B */
MORSEkar[67] = 21;  /* 00010101 C */
MORSEkar[68] = 9;   /* 00001001 D */
MORSEkar[69] = 2;   /* 00000010 E */
MORSEkar[70] = 20;  /* 00010100 F */
MORSEkar[71] = 11;  /* 00001011 G */
MORSEkar[72] = 16;  /* 00010000 H */
MORSEkar[73] = 4;
MORSEkar[74] = 30;
MORSEkar[75] = 13;
MORSEkar[76] = 18;
MORSEkar[77] = 7;
MORSEkar[78] = 5;
MORSEkar[79] = 15;
MORSEkar[80] = 22;
MORSEkar[81] = 27;
MORSEkar[82] = 10;
MORSEkar[83] = 8;
MORSEkar[84] = 3;
MORSEkar[85] = 12;
MORSEkar[86] = 24;
MORSEkar[87] = 14;
MORSEkar[88] = 25;
MORSEkar[89] = 29;
MORSEkar[90] = 19;

for (n = 65; n <= 90; n++)
   MORSEkar[n+32] = MORSEkar[n];

MORSEkar[48] = 63;  /* 0 */
MORSEkar[49] = 62;
MORSEkar[50] = 60;
MORSEkar[51] = 56;
MORSEkar[52] = 48;
MORSEkar[53] = 32;
MORSEkar[54] = 33;
MORSEkar[55] = 35;
MORSEkar[56] = 39;
MORSEkar[57] = 47;  /* 9 */

MORSEkar[46] = 106; /* Diverse tekens */
MORSEkar[44] = 115;
MORSEkar[63] = 76;
MORSEkar[45] = 97;
MORSEkar[61] = 49;
MORSEkar[58] = 35;
MORSEkar[59] = 85;
MORSEkar[60] = 45;
MORSEkar[40] = 45;
MORSEkar[41] = 109;
MORSEkar[47] = 41;
MORSEkar[34] = 82;
MORSEkar[36] = 200;
MORSEkar[39] = 94;
MORSEkar[126] = 34;
MORSEkar[43] = 42;
MORSEkar[94] = 13;
MORSEkar[62] = 104;
MORSEkar[132] = 26;
MORSEkar[148] = 23;
MORSEkar[129] = 28;

for (n = 0;n < 256;n++)
   Hellfont[n][0] = 0;

strcpy(&Hellfont[0][0],"0000000E");        /* waiting for next */
strcpy(&Hellfont[1][0],"00000000000000E"); /* character space */

strcpy(&Hellfont[32][0],"00000000000000000000000000000000000E"); /* space */
strcpy(&Hellfont[33][0],"13033300000000000000000000000000000E"); /* ! */
strcpy(&Hellfont[34][0],"00001300001300000000000001300001300E"); /* " */
strcpy(&Hellfont[35][0],"00303000333330003030003333300030300E"); /* # */
strcpy(&Hellfont[36][0],"03013200303030133333203030300132030E"); /* $ */
strcpy(&Hellfont[37][0],"03000300130030001300003013000300130E"); /* % */
strcpy(&Hellfont[38][0],"01303200303030030303001303200332000E"); /* & */
strcpy(&Hellfont[39][0],"0000000000003200003200000000E");        /* ' */
strcpy(&Hellfont[40][0],"00000000013200013032013000320000000E"); /* ( */
strcpy(&Hellfont[41][0],"00000001300032013032000132000000000E"); /* ) */
strcpy(&Hellfont[42][0],"03030300033300000300000333000303030E"); /* * */
strcpy(&Hellfont[43][0],"00030000003000033333000030000003000E"); /* + */
strcpy(&Hellfont[44][0],"01200001330000000000000000000000000E"); /* , */
strcpy(&Hellfont[45][0],"00030000003000000300000030000003000E"); /* - */
strcpy(&Hellfont[46][0],"03200000320000000000000000000000000E"); /* . */
strcpy(&Hellfont[47][0],"03000000130000001300000013000000130E"); /* / */
strcpy(&Hellfont[48][0],"01333200300030030003003000300133320E"); /* 0 */
strcpy(&Hellfont[49][0],"00000000000300000012003333300000000E"); /* 1 */
strcpy(&Hellfont[50][0],"03201200330030030303003013200300000E"); /* 2 */
strcpy(&Hellfont[51][0],"30000003000030120303003033300132000E"); /* 3 */
strcpy(&Hellfont[52][0],"00133320012000001200003333300012000E"); /* 4 */
strcpy(&Hellfont[53][0],"03000000300000030133201212120033012E"); /* 5 */
strcpy(&Hellfont[54][0],"01333300303012030120303012000133000E"); /* 6 */
strcpy(&Hellfont[55][0],"13000300130030001303000013300000130E"); /* 7 */
strcpy(&Hellfont[56][0],"03303301213212120301212132120330330E"); /* 8 */
strcpy(&Hellfont[57][0],"00033203012030121203003000300133320E"); /* 9 */

strcpy(&Hellfont[58][0],"03203200320320000000000000000000000E"); /* : */
strcpy(&Hellfont[59][0],"01203201330320000000000000000000000E"); /* ; */
strcpy(&Hellfont[60][0],"00030000013200003030001201200300030E"); /* < */
strcpy(&Hellfont[61][0],"00303000030300003030000303000030300E"); /* = */
strcpy(&Hellfont[62][0],"03000300120120003030000132000003000E"); /* > */
strcpy(&Hellfont[63][0],"00000300000030321303000013300000000E"); /* ? */

strcpy(&Hellfont[64][0],"01321200303030033203003000300133320E"); /* @ */
strcpy(&Hellfont[65][0],"03333200012130001203000121300333320E"); /* A */
strcpy(&Hellfont[66][0],"03000300333330030303003030300130320E"); /* B */
strcpy(&Hellfont[67][0],"01333200300030030003003000300120120E"); /* C */
strcpy(&Hellfont[68][0],"03000300333330030003003000300133320E"); /* D */
strcpy(&Hellfont[69][0],"03333300303030030303003000300300030E"); /* E */
strcpy(&Hellfont[70][0],"03333300003030000303000000300000030E"); /* F */
strcpy(&Hellfont[71][0],"03333300300030030003003030300333030E"); /* G */
strcpy(&Hellfont[72][0],"03333300003000000300000030000333330E"); /* H */
strcpy(&Hellfont[73][0],"00000000000000033333000000000000000E"); /* I */
strcpy(&Hellfont[74][0],"03300000300000030000003000000333330E"); /* J */
strcpy(&Hellfont[75][0],"03333300003000001300000303000320130E"); /* K */
strcpy(&Hellfont[76][0],"03333300300000030000003000000300000E"); /* L */
strcpy(&Hellfont[77][0],"03333300000120000030000001200333330E"); /* M */
strcpy(&Hellfont[78][0],"03333300000320000320000320000333330E"); /* N */
strcpy(&Hellfont[79][0],"03333300300030030003003000300333330E"); /* O */
strcpy(&Hellfont[80][0],"03000300333330030303000030300001320E"); /* P */
strcpy(&Hellfont[81][0],"03333300300030033003003333303300000E"); /* Q */
strcpy(&Hellfont[82][0],"03333300003030000303000330300321320E"); /* R */
strcpy(&Hellfont[83][0],"03013200303030030303003030300132030E"); /* S */
strcpy(&Hellfont[84][0],"00000300000030033333000000300000030E"); /* T */
strcpy(&Hellfont[85][0],"01333300300000030000003000000133330E"); /* U */
strcpy(&Hellfont[86][0],"03333300130000001300000013000000130E"); /* V */
strcpy(&Hellfont[87][0],"01333300300000013300003000000133330E"); /* W */
strcpy(&Hellfont[88][0],"03201300030300001320000303000320130E"); /* X */
strcpy(&Hellfont[89][0],"00001300001300033300000013000000130E"); /* Y */
strcpy(&Hellfont[90][0],"03200300332030030303003013300300130E"); /* Z */

strcpy(&Hellfont[94][0],"00003000000120000003000001200000300E"); /* ^ */
strcpy(&Hellfont[91][0],"00000000333330030003003000300000000E"); /* [ */
strcpy(&Hellfont[92][0],"00001300001300001300001300000300000E"); /* \ */
strcpy(&Hellfont[93][0],"00000000300030030003003333300000000E"); /* ] */
strcpy(&Hellfont[95][0],"03000000300000030000003000000300000E"); /* _ */
strcpy(&Hellfont[123][0],"00000000003000013332013000320000000E"); /* { */
strcpy(&Hellfont[124][0],"000000013303320000000E");              /* | */
strcpy(&Hellfont[125][0],"00000001300032013332000030000000000E"); /* } */


for (n = 0; n <= 75; n++)
   {
    Wisregel[n] = ' ';
    Wisregel[n+1] = 0;
   }

for (n = 0; n <= MAXINPUT; n++)
   {
    Wisbuffer[n] = ' ';
    Wisbuffer[n+1] = 0;
   }

for (n = 0; n <= 75; n++)
   {
    Wisregel[n] = ' ';
    Wisregel[n+1] = 0;
   }

Get_settings();

pauze(1);

Menu_A();

Store_settings();

tekstkleur=7;
schermkleur=0;  /* 0 default */

Scherm(25);
}



/****************************************************************************
 *
 * void Menu_A(void)
 *
 ****************************************************************************/
void Menu_A(void)
{
static int keuze;
int n,x;
int windowok=0;

keuze = 0;

do
  {
   Scherm(25);
   window (1,1,9,80);
   Print (3,30,"FELDHELL MACHINE");
   Print (5,35,"PA2OHH");
   Print (7,31,"V1.1 26-05-2000");

   window(13,1,20,31);
   Print (14,4,"1. START HELL");
   Print (15,4,"2. REPLAY");
   Print (16,4,"3. EXPLANATION");
   Print (17,4,"4. END");

   In_ntext(19,4,1,kar);

   keuze = atoi(kar);

   if (keuze == 1)
     {
      Replay = 0;
      Mainloop();
      keuze = 0;
     }

   if (keuze == 2)
     {
      Replay_hrx();
      keuze = 0;
     }

   if (keuze == 3)
     {
      Uitleg();
      keuze = 0;
     }
  }
while (keuze != 4);
}



/****************************************************************************
 *
 * void Mainloop(void)  De hoofdroutine
 *
 ****************************************************************************/
void Mainloop(void)
{
unsigned int Tonel;
unsigned int Toneh;
unsigned long Z;
int n,x;
float Calc;

Pixels = 2 * Resolution;
Halfpixels = Pixels / 2;
MS = Symbolrate / Pixels;
Max_offset = Pixels * 7;       /* 7 symbols */
Symbolwidth = Pixels / 3;
if (Symbolwidth < 1)
  Symbolwidth = 1;
if (Extra_res != 0)
  Symbolwidth++;
Row_step = 2 * Max_offset + Row_space;
PixelrowA1 = 0;
PixelrowB1 = Max_offset;
PixelrowA2 = PixelrowA1;
PixelrowB2 = PixelrowB1;
PixelcolomA1 = 1;
PixelcolomA2 = PixelcolomA1 + 5 * Symbolwidth;
PixelcolomB1 = PixelcolomA1 + Symbolwidth;
PixelcolomB2 = PixelcolomB1 + 5 * Symbolwidth;
Pixeloffset = Max_offset;

NewTX_on = 0;
Update_screen = 1;

Setport(0);
Newdisplay();

Fillgrey_array();

RXnaam[0] = 0;

Max_change_wres = Max_colom - 10 * Symbolwidth; /* No wresolution change */
Row_check = Max_row - Max_offset;
Colom_check = Max_colom - Symbolwidth - 1;

InsNewclock();

while(1)
  {
   if (Update_screen == 1)
     {
      Update_screen = 0;
      New_buffer = 1;

      _displaycursor(_GCURSOROFF);

      Puntlng = (float)1200 / MS / Wpm;     /* in interruptcounts */
      Streeplng = 3 * Puntlng;
      SPlng = (SPrate-1) * Puntlng;

      if (Replay != 0)
	{
	 Print(Lijn2,3,"RP");
	 Print(Lijn4,3,"F1: +1e3");
	 Print(Lijn4,17,"F2: +1e4");
	 Print(Lijn4,30,"F3: +1e5");
	 Print(Lijn4,43,"F4: +1e6");
	}

      else
	{
	 if (TX_on == 0)
	   Print(Lijn2,3,"RX");

	 if (TX_on == 1)
	   Print(Lijn2,3,"TX");

	 if (TX_on == 2)
	   Print(Lijn2,3,"CW");

	 sprintf(Pbuf,"W%.0f",Wpm);
	 Print(Lijn4,76,Pbuf);
	 sprintf(Pbuf,"SP%i",(int)SPrate);

	 Print(Lijn4,3,"F1: HELL RX");
	 Print(Lijn4,17,"F2: HELL TX ");
	 Print(Lijn4,30,"F3: CW TX ");
	 Print(Lijn4,43,"F4: TUNE");

	 if (Dble_width == 0)
	   Print(Lijn4,58,"F5: NORMAL FIGS");
	 else
	   Print(Lijn4,58,"F5: DOUBLE FIGS");

	 if (Tone_on == 0)
	   Print(Lijn5,3,"F6: TONE OFF");
	 else
	   Print(Lijn5,3,"F6: TONE ON ");

	 if (TXRXstate == 0)
	   Print(Lijn5,58,"F10: TX-RX_OFF");

	 if (TXRXstate == 1)
	   Print(Lijn5,58,"F10: TX-PC_INT");

	 if (TXRXstate == 2)
	   Print(Lijn5,58,"F10: TX-RX_ON ");
	}

      Print(Lijn5,17,"F7: INV SCRN ");

      if (Scale == 0)
	Print(Lijn5,30,"F8: NORMAL ");
      if (Scale == 1)
	Print(Lijn5,30,"F8: WEAK   ");
      if (Scale == 2)
	Print(Lijn5,30,"F8: STRONG ");

      if (Extra_res == 1)
	Print(Lijn5,43,"F9: WIDE FIGS");
      if (Extra_res == 0)
	Print(Lijn5,43,"F9: NARR FIGS");


      if (RXnaam[0] != 0)
	{
	 strcpy (Pbuf,"S ");
	 Pbuf[1] = RXnaam[6];
	}
      else
	strcpy (Pbuf,"  ");
      Print(Lijn5,76,Pbuf);
     }

   inkey();

   if (keyvalue == 27)
     break;

   if (Replay == 0)
     {
      if (Stat_state != 0 && Stat_pixel > 100)
	{
	 Calc = (float)Stat_pixelon / (float)Stat_pixel;
	 Calc *= 100;
	 sprintf(Pbuf,"%.1f PCT / %lu Hellchar.        ",Calc,Stat_Hchar);
	 Print(Lijn0,2,Pbuf);
	}

      if (Stat_state != 0 && Stat_CW > 100)
	{
	 Calc = (float)Stat_CWon / (float)Stat_CW;
	 Calc *= 100;
	 sprintf(Pbuf,"%.1f PCT    %lu CWchar.        ",Calc,Stat_CWchar);
	 Print(Lijn0,40,Pbuf);
	}

      if (keyvalue == 187)                   /* F1 HELL RX */
	{
	 Mode_change = 1;
	 NewTX_on = 0;
	 Update_screen = 1;
	 keyvalue = 0;
	}

      if (keyvalue == 188)                   /* F2 HELL TX */
	{
	 Mode_change = 1;
	 NewTX_on = 1;
	 Update_screen = 1;
	 keyvalue = 0;
	}

      if (keyvalue == 189)                   /* F3 CW TX */
	{
	 Mode_change = 1;
	 NewTX_on = 2;
	 Update_screen = 1;
	 keyvalue = 0;
	}

      if (keyvalue == 190 && TX_on != 0 && Tkvalue == 0 )   /* F4 Tune TX */
	{
	 _disable();
	 Setport(2);
	 Tune_count = 1 + 1000 / MS;         /* 1000 ms tune signaal */
	 _enable;
	 keyvalue = 0;
	}

      if (keyvalue == 191)                   /* F5 Send double width */
	{
	 if (Dble_width == 0)
	   Dble_width = 1;
	 else
	   Dble_width = 0;

	 Update_screen = 1;
	 keyvalue = 0;
	}

      if (keyvalue == 192)                   /* F6 Beep on - off */
	{
	 if (Tone_on == 0)
	   Tone_on = 1;
	 else
	   Tone_on = 0;
	 Update_screen = 1;
	 keyvalue = 0;
	}

      if (keyvalue == 196)                   /* F10 TXRX state  */
	{                                    /* 0=RX off if TX */
	 TXRXstate++;                        /* 1=PC data if TX */
	 if (TXRXstate > 2)                  /* 2=RX on if TX */
	   TXRXstate = 0;
	 Update_screen = 1;
	 keyvalue = 0;
	}

      if (keyvalue >= 248 && keyvalue <= 257)  /* messages alt1.. alt0 */
	{
	 strcpy (Msgnaam,"HELLMSG0.TXT");

	 if (keyvalue != 257)
	   Msgnaam[7] = (char)(keyvalue - 199);

	 keyvalue = 0;
	}

      if (keyvalue == 199)                /* HOME toets clear buffer */
	{
	 _disable();
	 Inputbuf[0] = 0;
	 Input_count = 0;
	 _enable();
	 Print (Lijn2,INPUTPLAATS,Wisbuffer);

	 New_buffer = 1;
	 Update_screen = 1;
	 keyvalue = 0;

	 if (MSGfileopen != 0)
	   {
	    Msgnaam[0] = 0;
	    fclose(MSGfile);
	    MSGfileopen = 0;
	   }
	}

      if (keyvalue == 201)                /* Pgup statistics_on */
	{
	 Print(Lijn0,2,Wisbuffer);
	 _disable();
	 Stat_Hchar = 0;
	 Stat_pixel = 0;
	 Stat_pixelon = 0;
	 Stat_CWchar = 0;
	 Stat_CW = 0;
	 Stat_CWon = 0;
	 Stat_state = 1;
	 _enable();
	}

      if (keyvalue == 209)                /* Pgdn statistics_off */
	{
	 Print(Lijn0,2,Wisbuffer);
	 Stat_state = 0;
	}
     }

   if (Replay != 0)
     {
      if (keyvalue == 187)                   /* F1 Replay skip 1e3 */
	Replayskip(1000);


      if (keyvalue == 188)                   /* F2 Replay skip 1e4 */
	Replayskip(10000);

      if (keyvalue == 189)                   /* F3 Replay skip 1e5 */
	Replayskip(100000);

      if (keyvalue == 190)                   /* F4 Replay skip 1e6 */
	Replayskip(1000000);
     }


   if (keyvalue == 193)                    /* F7 Inv_scrn */
     {
      if (Inv_scrn == 0)
	Inv_scrn = 1;
      else
	Inv_scrn = 0;

      Fillcolor_regs();                   /* fill color registers */

      Update_screen = 1;
      keyvalue = 0;
     }

   if (keyvalue == 194)                   /* F8 Grey scale */
     {
      Scale++;
      if (Scale > 2)
	Scale = 0;
      Update_screen = 1;
      keyvalue = 0;
     }

   if (keyvalue == 195 && Inc_symbolwidth == 0) /* F9 Extra / norm hor. res */
     {
      if (Extra_res == 0)
	{
	 Extra_res = 1;
	 Inc_symbolwidth = 1;
	}
      else
	{
	 Extra_res = 0;
	 Inc_symbolwidth = -1;
	}

      Update_screen = 1;
      keyvalue = 0;
     }

   if (keyvalue == 200)                /* CW Wpm++ */
     {
      if (Wpm < 30)
	Wpm += 1;
      Update_screen = 1;
      keyvalue = 0;
     }

   if (keyvalue == 208)                /* CW Wpm-- */
     {
      if (Wpm >= 11)
	Wpm -= 1;
      Update_screen = 1;
      keyvalue = 0;
     }


   if (keyvalue == 261)                /* Save data HELLRX1.HRX */
     {
      strcpy(RXnaam,"HELLRX1.HRX");
      RXfile_handle();
      Update_screen = 1;
      keyvalue = 0;
     }

   if (keyvalue == 262)                /* Save data HELLRX1.HRX */
     {
      strcpy(RXnaam,"HELLRX2.HRX");
      RXfile_handle();
      Update_screen = 1;
      keyvalue = 0;
     }

   if (NewTX_on == 0)                         /* RX mode */
     {
      if (Mode_change == 1)                   /* Van TX naar RX */
	{
	 Mode_change = 0;
	 _disable();
	 Tune_count = 0;                      /* reset Tune */
	 Setport(0);                          /* RX mode */
	 _enable;
	 TX_on = NewTX_on;
	}
     }

   if (NewTX_on != 0)                            /* TX mode */
     {
      if (Mode_change == 1)                   /* Van RX naar TX */
	{
	 Mode_change = 0;
	 _disable();
	 Setport(1);                          /* TX STBY */
	 Intpls = 100 / MS;                   /* 100 ms wachttijd */
	 _enable;

	 Z = 1193181 / (long)Tone_freq;
	 Toneh = (int)(Z / 256);
	 Tonel = (int)(Z - (long)Toneh * 256);
	 outp(67,182);                        /* Set timer mode */
	 outp(66,Tonel);
	 outp(66,Toneh);                      /* Set frequency */

	 do                                   /* wait */
	   {
	    _disable();
	    x = Intpls;
	    _enable();
	   }
	 while (x != 0);

	 Symbolcnt = 0;                       /* set some variables */
	 Pixelcnt = Pixels;
	 Dble_widthcnt = 14;
	 Tkvalue = Inputbuf[0];
	 Interrupt_count = 0;
	 TX_on = NewTX_on;
	}
     }

   if (Replay == 0)
     New_character();
   Helldisplay();
  }

InsOldclock();

Setport(0);

if (MSGfileopen != 0)
  {
   Msgnaam[0] = 0;
   fclose(MSGfile);
   MSGfileopen = 0;
  }

if (RXfileopen != 0)
  {
   RXnaam[0] = 0;
   fclose(RXfile);
   RXfileopen = 0;
  }
}


/****************************************************************************
 *
 * void Newdisplay(void)  Creates an empty HELL screen
 *
 ****************************************************************************/
void Newdisplay(void)
{
int Dmode;
char a,b;

/*_setvideomode (0x101);*/
/* 30 tekstregels, 480x640 beeld */

/*_setvideomode (0x103);*/
/* 38 tekstregels, 600x800 beeld */

/*_setvideomode (0x105);*/
/* 49 tekstregels, ongeveer 120 tekens op regel!, 768x1024 beeld */

if (Screenmode == 0) /* VGA mode 18d */
  {
   /*_setvideomode (18d)*/
   /* 480 * 640 VGA video mode en 16 grijstinten */

   _asm
       {
	mov ax,18;
	int 0x10;
       }

   Lijn0 = 24;
   Max_row=385;   /* Maximum row */
   Max_colom=639; /* Maximum colom */

   b = 48;

   for (a = 0;a < 16;a++) /* zet palette registers naar DAC 48 - 63 */
      {
       _asm
	   {
	    mov ah,0x10;
	    mov al,0;
	    mov bh,b;
	    mov bl,a;
	    int 0x10;
	   }
       b++;
      }
  }

if (Screenmode == 1)
  {
   Dmode = 0x101;
   Lijn0 = 24;
   Max_row=385;   /* Maximum row */
   Max_colom=639; /* Maximum colom */
  }

if (Screenmode == 2)
  {
   Dmode = 0x103;
   Lijn0 = 32;
   Max_row=512;   /* Maximum row */
   Max_colom=799; /* Maximum colom */
  }

if (Screenmode == 3)
  {
   Dmode = 0x105;
   Lijn0 = 42;
   Max_row=671;    /* Maximum row */
   Max_colom=1023; /* Maximum colom */
  }

Lijn1 = Lijn0 + 1;
Lijn2 = Lijn1 + 1;
Lijn3 = Lijn2 + 1;
Lijn4 = Lijn3 + 1;
Lijn5 = Lijn4 + 1;
Lijn6 = Lijn5 + 1;

if (Screenmode != 0)                 /* SVGA */
  {
   _asm
       {
	mov ax,0x4f02;
	mov bx,Dmode;
	int 0x10;
       }
  }

 Fillcolor_regs();                   /* fill color registers */
 New_buffer = 1;

 window(Lijn1,1,Lijn6,79);
 Hline(Lijn3,1,79);
 Vline(Lijn1,6,Lijn3);
 Vline(Lijn3,75,Lijn6);
 Update_screen = 1;
 Tekstbuf_plaats = 0;
 Newpage = 0;
}



/****************************************************************************
 *
 * void New_character(void)  Character handling routine
 *
 ****************************************************************************/
void New_character(void)
{
if (Msgnaam[0] != 0 && Input_count < MAXINPUT)
  Msgkar();

if (keyvalue > 96 && keyvalue < 123)    /* lower to uppercase */
  keyvalue -= 32;

if (keyvalue == 158 || keyvalue == 142)
  keyvalue = 132;                       /* alt A en  naar  */

if (keyvalue == 150 || keyvalue == 154)
  keyvalue = 129;                       /* alt U en  naar  */

if (keyvalue == 152 || keyvalue == 153)
  keyvalue = 148;                       /* alt O en  naar  */

if (keyvalue == 8 || keyvalue == 211)   /* delete */
  {
   if (Input_count > 0)
     {
      _disable();
      Input_count--;
      Inputbuf[Input_count] = 0;
      _enable();
      New_buffer = 1;
     }
   keyvalue = 0;
  }

if (keyvalue > 31 && keyvalue < 180 && Input_count < MAXINPUT)
  {
   _disable();
   Inputbuf[Input_count] = keyvalue;
   Input_count++;
   Inputbuf[Input_count] = 0;
   _enable();
   New_buffer = 1;
  }

if (New_buffer != 0)
  {
   New_buffer = 0;
   strcpy(Pbuf,Inputbuf);
   strcat(Pbuf,"_ ");
   Print (Lijn2,INPUTPLAATS,Pbuf);
  }
}


/****************************************************************************
 *
 * void Helldisplay(void)  Writes pixels to the HELL screen
 *
 ****************************************************************************/
void Helldisplay(void)
{
 int n,V,X,X1,Y,Y1;

 while(1)
   {
    if (Replay != 0)
      {
       if (Intpls != 0)
	 break;

       Intpls = 1;        /* 1 pixel waiting time speed control */

       if (feof(REPLAYfile) == 0)
	 {
	  X = fgetc(REPLAYfile);
	  Pixelcount++;
	  Pixelprint--;
	 }
       else
	 {
	  fclose(REPLAYfile);
	  REPLAYfile = fopen(REPLAYnaam,"rb");
	  Pixelcount = 0;
	  Pixelprint = PPIXELS;
	  break;
	 }

      if (Pixelprint == 0)
	{
	 Pixelprint = PPIXELS;
	 sprintf(Pbuf,"Pixels:  %lu               ",Pixelcount);
	 Print (Lijn2,INPUTPLAATS,Pbuf);
	}
      }

    else
     {
      X = Pixeltube[Tubecnt];
      if (X == 0xffff)
	break;

      X -= AD_offset;
      if (X < 0)
	X = 0;
      if (X > 255)
	X = 255;
     }

    if (RXfileopen != 0)             /* write RX data */
      fputc(X,RXfile);

    V = Grey[Scale][X];

    Y = PixelrowA1 + Pixeloffset;
    X = PixelcolomA1;
    Y1 = PixelrowB1 + Pixeloffset;
    X1 = PixelcolomB1;

    for (n = 0;n < Symbolwidth;n++)
       {
	_asm
	    {
	     mov ax,V;             /* kleur in al */
	     mov ah,0x0c;
	     xor bx,bx;
	     mov cx,X;             /* kolom */
	     mov dx,Y;             /* rij  */
	     int 0x10;
	     mov ax,V;             /* kleur in al */
	     mov ah,0x0c;
	     xor bx,bx;
	     mov cx,X1;            /* kolom */
	     mov dx,Y1;            /* rij  */
	     int 0x10;
	    }
	X++;
	X1++;
       }
    _asm
	{                      /* cursor line */
	 mov ax,0;             /* kleur in al */
	 mov ah,0x0c;
	 xor bx,bx;
	 mov cx,X;             /* kolom */
	 mov dx,Y;             /* rij  */
	 int 0x10;
	 mov ax,0;             /* kleur in al */
	 mov ah,0x0c;
	 xor bx,bx;
	 mov cx,X1;            /* kolom */
	 mov dx,Y1;            /* rij  */
	 int 0x10;
	}

    if (PixelrowA2 != PixelrowA1) /* print already part of last line on next */
      {
       Y = PixelrowA2 + Pixeloffset;
       X = PixelcolomA2;

       for (n = 0;n < Symbolwidth;n++)
	  {
	   _asm
	       {
		mov ax,V;             /* kleur in al */
		mov ah,0x0c;
		xor bx,bx;
		mov cx,X;             /* kolom */
		mov dx,Y;             /* rij  */
		int 0x10;
	       }
	   X++;
	  }
      }

    if (PixelrowB2 != PixelrowB1) /* print already part of last line on next */
      {
       Y = PixelrowB2 + Pixeloffset;
       X = PixelcolomB2;

       for (n = 0;n < Symbolwidth;n++)
	  {
	   _asm
	       {
		mov ax,V;             /* kleur in al */
		mov ah,0x0c;
		xor bx,bx;
		mov cx,X;             /* kolom */
		mov dx,Y;             /* rij  */
		int 0x10;
	       }
	   X++;
	  }
      }

    Pixeloffset--;

    if (Pixeloffset == 0)
      {
       Pixeloffset = Max_offset;

       if (Inc_symbolwidth != 0 && PixelcolomA1 < Max_change_wres)
	 {
	  Symbolwidth += Inc_symbolwidth;
	  PixelcolomA2 = PixelcolomA1 + 5 * Symbolwidth;
	  PixelcolomB1 = PixelcolomA1 + Symbolwidth;
	  PixelcolomB2 = PixelcolomB1 + 5 * Symbolwidth;
	  Colom_check = Max_colom - Symbolwidth - 1;
	  Inc_symbolwidth = 0;
	 }

       PixelcolomA2 += Symbolwidth;

       if (PixelcolomA2 > Colom_check)
	 {
	  PixelcolomA2 = 1;
	  if (Newpage == 1)             /* To top of page */
	    {
	     Newpage = 0;
	     PixelrowA2 = 0;
	    }
	  else
	    PixelrowA2 += Row_step;
	 }

       PixelcolomA1 += Symbolwidth;

       if (PixelcolomA1 > Colom_check)
	 {
	  PixelcolomA1 = PixelcolomA2;
	  PixelcolomA2 = PixelcolomA1 + 5 * Symbolwidth;
	  PixelrowA1 = PixelrowA2;
	 }

       PixelcolomB2 += Symbolwidth;

       if (PixelcolomB2 > Colom_check)
	 {
	  PixelcolomB2 = 1;
	  PixelrowB2 += Row_step;
	 }

       if (PixelrowB2 > Row_check)
	 {
	  Newpage = 1;
	  PixelrowB2 = Max_offset;
	 }

       PixelcolomB1 += Symbolwidth;

       if (PixelcolomB1 > Colom_check)
	 {
	  PixelcolomB1 = PixelcolomB2;
	  PixelcolomB2 = PixelcolomB1 + 5 * Symbolwidth;
	  PixelrowB1 = PixelrowB2;
	 }
      }

    Tubecnt++;
    Tubecnt &= 255;
   }
}


/****************************************************************************
 *
 * void RXfile_handle(void) open/close HELLRX1.HRX of HELLRX2.HRX file
 *
 ****************************************************************************/
void RXfile_handle(void)
{
 keyvalue = 0;

 if (RXfileopen != 0 && RXnaam[0] != 0)
   {
    fclose(RXfile);
    RXnaam[0] = 0;
    RXfileopen = 0;
    return;
   }

 if (RXfileopen == 0 && RXnaam[0] != 0)
   {
    if ((RXfile = fopen(RXnaam,"ab")) == NULL)
      {
       RXnaam[0] = 0;
       return;
      }
    else
      RXfileopen = 1;
   }
}



/****************************************************************************
 *
 * void Msgkar(void) zet karakter uit file in keyvalue
 *
 ****************************************************************************/
void Msgkar(void)
{
 int k;

 keyvalue = 0;

 if (MSGfileopen != 0 && Msgnaam[0] == 0)
   {
    fclose(MSGfile);
    MSGfileopen = 0;
    return;
   }

 if (MSGfileopen == 0)
   {
    if ((MSGfile = fopen(Msgnaam,"rt")) == NULL)
      {
       Msgnaam[0] = 0;
       return;
      }
    else
      MSGfileopen = 1;
   }

    if (feof(MSGfile) == 0)
      keyvalue = fgetc (MSGfile);
    else
      {
       Msgnaam[0] = 0;
       fclose(MSGfile);
       MSGfileopen = 0;
      }

 keyvalue &= 255;
}


/****************************************************************************
 *
 * void Store_settings(void) Save settings variabelen
 *
 ****************************************************************************/
void Store_settings(void)
{
 static FILE *file;
 char naam[]="Hell01.ini";

 if ((file = fopen(naam,"wt")) == NULL)
   return;

 sprintf(Pbuf,"Videomode    (0-3):  %i \n",Screenmode);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Symbolrate 8.163ms:  %f \n",Symbolrate);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Resolution   (1-4):  %i \n",Resolution);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Row Space    (0-9):  %i \n",Row_space);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Wpm (CW)          :  %f \n",Wpm);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Tone_freq     (Hz):  %i \n",Tone_freq);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Screen green(0-63):  %i \n",SCRN_green);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Screen blue (0-63):  %i \n",SCRN_blue);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Screen red  (0-63):  %i \n",SCRN_red  );
 fputs (Pbuf,file);

 sprintf(Pbuf,"Text green  (0-63):  %i \n",TEXT_green);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Text blue   (0-63):  %i \n",TEXT_blue);
 fputs (Pbuf,file);

 sprintf(Pbuf,"Text red    (0-63):  %i \n",TEXT_red  );
 fputs (Pbuf,file);

 sprintf(Pbuf,"Detector     (0-1):  %i \n",Detector);
 fputs (Pbuf,file);

 sprintf(Pbuf,"AD_offset(100-150):  %i \n",AD_offset );
 fputs (Pbuf,file);

 sprintf(Pbuf,"F6 Tone_on   (0-1):  %i \n",Tone_on);
 fputs (Pbuf,file);

 sprintf(Pbuf,"F7 Inv screen(0-1):  %i \n",Inv_scrn);
 fputs (Pbuf,file);

 sprintf(Pbuf,"F8 Det Scale (0-2):  %i \n",Scale);
 fputs (Pbuf,file);

 sprintf(Pbuf,"F9 Extra res (0-1):  %i \n",Extra_res);
 fputs (Pbuf,file);

 sprintf(Pbuf,"=========================================\n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"Videomode 0: VGA 480*640 16 grey levels. \n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"Videomode 1: SVGA 480*640 64 grey levels. \n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"Videomode 2: SVGA 600*800 64 grey levels. \n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"Videomode 3: SVGA 768*1024 64 grey levels. \n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"Symbolrate 8.163 ms for standard Feldhell.\n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"2xResolution value is pixels per Symbol.\n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"Row space is space between two Hell display lines.\n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"Screen / Text colors: Text color only active in SVGA.\n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"Detector: 0 for on/off LA0BX detector 1 for A/D converter.\n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"AD-offset is A/D converter value for black.\n");
 fputs (Pbuf,file);
 sprintf(Pbuf,"F6, F7, F8, F9 are stored here at program end.\n");
 fputs (Pbuf,file);

 fclose(file);
}


/****************************************************************************
 *
 * void Get_settings(void) Initialiseert variabelen
 *
 ****************************************************************************/
void Get_settings(void)
{
 static FILE *file;
 char naam[]="Hell01.ini";

 if ((file = fopen(naam,"rt")) == NULL)
   return;

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Screenmode = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Symbolrate = atof(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Resolution = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Row_space = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Wpm = atof(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Tone_freq = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    SCRN_green = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    SCRN_blue = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    SCRN_red = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    TEXT_green = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    TEXT_blue = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    TEXT_red = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Detector = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    AD_offset = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Tone_on = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Inv_scrn = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Scale = atoi(&Pbuf[20]);
   }

 if (feof(file) == 0)
   {
    fgets(Pbuf,50,file);
    Extra_res = atoi(&Pbuf[20]);
   }

 fclose(file);
}



/****************************************************************************
 *
 * void Fillcolor_regs(void)
 *
 ****************************************************************************/
void Fillcolor_regs(void)
{
 int c;
 char v=0;


if (Screenmode == 0)    /* VGA */
  {
   if (Inv_scrn == 0)
     {
      v = 0;

      for (c=49; c<64; c++) /* vul Video DAC 49-63 met 16 grijswaarden */
	 {
	  _asm
	     {
	      mov ah,0x10;
	      mov al,0x10;
	      mov bx,c;
	      mov ch,v; /* groen */
	      mov cl,v; /* blauw */
	      mov dh,v; /* rood */
	      int 0x10;
	     }
	  v+=4;
	 }
     }

   if (Inv_scrn == 1)
     {
      v = 60;

      for (c=49; c<64; c++) /* vul Video DAC 49-63 met 15 grijswaarden */
	 {
	  _asm
	     {
	      mov ah,0x10;
	      mov al,0x10;
	      mov bx,c;
	      mov ch,v; /* groen */
	      mov cl,v; /* blauw */
	      mov dh,v; /* rood */
	      int 0x10;
	     }
	  v-=4;
	 }
     }

   /* achtergrondcolor zetten */
   _asm
       {
	mov ah,0x10;
	mov al,0x10;
	mov bx,48;          /* color 0 = DAC 48 is achtergrond */
	mov ch,SCRN_green;  /* groen */
	mov cl,SCRN_blue ;  /* blauw */
	mov dh,SCRN_red  ;  /* rood  */
	int 0x10;
       }
  }


if (Screenmode != 0)    /* SVGA */
  {
   /* kleurregister 128 rood maken */
   _asm
       {
	mov ah,0x10;
	mov al,0x10;
	mov bx,128;
	mov ch,0;  /* groen */
	mov cl,0;  /* blauw */
	mov dh,63; /* rood, 63 */
	int 0x10;
       }

   /* textcolor kleurrregister 7 zetten */
   _asm
       {
	mov ah,0x10;
	mov al,0x10;
	mov bx,7;          /* 7 wordt gebruikt voor tekst */
	mov ch,TEXT_green; /* groen */
	mov cl,TEXT_blue;  /* blauw */
	mov dh,TEXT_red;   /* rood  */
	int 0x10;
       }

   /* achtergrondcolor zetten */
   _asm
       {
	mov ah,0x10;
	mov al,0x10;
	mov bx,0;           /* 0 wordt gebruikt voor achtergrond */
	mov ch,SCRN_green;  /* groen */
	mov cl,SCRN_blue ;  /* blauw */
	mov dh,SCRN_red  ;  /* rood  */
	int 0x10;
       }

   /* 64 black / white levels in reg 64 - 128 */

   if (Inv_scrn == 0)
     {
      v = 0;
      for (c=64; c<128; c++) /* zet 64 grijswaarden in color 64 - 127 */
	 {
	  _asm
	      {
	       mov ah,0x10;
	       mov al,0x10;
	       xor bx,bx;
	       mov bx,c;
	       mov ch,v; /* groen */
	       mov cl,v; /* blauw */
	       mov dh,v; /* rood */
	       int 0x10;
	      }
	  v++;
	 }
     }

   if (Inv_scrn == 1)
     {
      v = 63;
      for (c=64; c<128; c++) /* zet 64 grijswaarden in color 64 - 127 */
	 {
	  _asm
	      {
	       mov ah,0x10;
	       mov al,0x10;
	       mov bx,c;
	       mov ch,v; /* groen */
	       mov cl,v; /* blauw */
	       mov dh,v; /* rood */
	       int 0x10;
	      }
	  v--;
	 }
     }
  }

}


/****************************************************************************
 *
 * void Fillgrey_array(void)
 *
 ****************************************************************************/
void Fillgrey_array(void)
{
 double A;
 int n;

 if (Screenmode == 0)
   {
    /* lin scale */
    for (n = 0; n < 256;n++)
       {
	A = pow(((double)n / 255),1) * 14 + 1.0001;
	Grey[0][n] = (int)A;
       }

    /* low scale */
    for (n = 0; n < 256;n++)
       {
	A = pow(((double)n / 255),0.71) * 14 + 1.0001;
	Grey[1][n] = (int)A;
       }

    /* high scale */
    for (n = 0; n < 256;n++)
       {
	A = pow(((double)n / 255),2) * 14 + 1.0001;
	Grey[2][n] = (int)A;
       }
   }

 if (Screenmode != 0)
   {
    /* lin scale */
    for (n = 0; n < 256;n++)
       {
	A = pow(((double)n / 255),1) * 63 + 64.0001;
	Grey[0][n] = (int)A;
       }

    /* low scale */
    for (n = 0; n < 256;n++)
       {
	A = pow(((double)n / 255),0.71) * 63 + 64.0001;
	Grey[1][n] = (int)A;
       }

    /* high scale */
    for (n = 0; n < 256;n++)
       {
	A = pow(((double)n / 255),2) * 63 + 64.0001;
	Grey[2][n] = (int)A;
       }
   }
}


/****************************************************************************
 *
 * void Replay_hrx(void)
 *
 ****************************************************************************/
void Replay_hrx(void)
{
 strcpy(REPLAYnaam,"HELLRX1.HRX");

 Scherm(25);

 window(1,1,14,80);

 Print(2,25,"REPLAY SAVED HELL DATA");
 Print(3,25,"======================");

 Print(5,3,"RECEIVED HELL DATA CAN BE STORED BY PRESSING F11 OR F12.");
 Print(6,3,"THE DATA IS STORED IN HELLRX1.HRX (F11) OR HELLRX2.HRX (F12).");
 Print(7,3,"YOU CAN RENAME OR DELETE THE FILES IN DOS.");
 Print(8,3,"THE FUNCTION KEYS F7, F8, F9 CAN BE USED IN REPLAY MODE.");
 Print(10,3,"GIVE THE NAME OF THE FILE YOU WANT TO REPLAY (OR PRESS ESCAPE).");

 Print(12,3,"FILENAME:   ");
 In_utext(12,13,20,REPLAYnaam);

 if (REPLAYnaam[0] == 27)
   return;

 if ((REPLAYfile = fopen(REPLAYnaam,"rb")) == NULL)
   {
    sprintf(Pbuf,"CANNOT FIND FILE: %s",REPLAYnaam);
    Print(18,3,Pbuf);
    Print(20,3,"PRESS ANY KEY TO CONTINUE");

    do
      {
       inkey();
      }
    while (keyvalue == 0);
    return;
   }

 Pixelcount = 0;
 Pixelprint = PPIXELS;

 Replay = 1;
 Mainloop();
}



/****************************************************************************
 *
 * void Replayskip(long int skips)
 *
 ****************************************************************************/
void Replayskip(long int skips)
{
 long int n;
 int X;

 for (n = 0; n < skips; n++)
    {
     if (feof(REPLAYfile) == 0)
       {
	X = fgetc(REPLAYfile);
	Pixelcount++;
	Pixelprint--;
	if (Pixelprint == 0)
	  Pixelprint = PPIXELS;
       }
     else
       {
	fclose(REPLAYfile);
	REPLAYfile = fopen(REPLAYnaam,"rb");
	Pixelcount = 0;
	Pixelprint = PPIXELS;
	break;
       }
    }
}



/****************************************************************************
 *
 * void InsNewclock(void)
 *
 ****************************************************************************/

void InsNewclock (void)
{
 float Counter=(float)MS;
 float Counterl;
 float Counterh;

 if (Intrun == 1)         /* Al geactiveerd */
   return;

 Counterh=1000*Counter/0.838095/256;
 Counterh=floor(Counterh);
 Counterl=1000*Counter/0.838095-256*Counterh;
 Counterl=floor(Counterl);
 _disable();
 Oldclock=_dos_getvect (0x08);
 _dos_setvect(0x08,TXport);
 outp(0x43,0x34);           /* mode 2, up naar 0 counter */
 outp(0x40,(int)Counterl);
 outp(0x40,(int)Counterh);
 _enable();
 Intrun = 1;
}


/****************************************************************************
 *
 * void InsOldclock(void)
 *
 ****************************************************************************/
void InsOldclock (void)
{
 if (Intrun == 0)         /* Al gedeactiveerd */
   return;
 _disable();
 _dos_setvect(0x08,Oldclock);
 outp(0x43,0x34);
 outp(0x40,0xff);
 outp(0x40,0xff);
 _enable();
 Intrun = 0;
}




/****************************************************************************
 *
 * static void _interrupt _far TXport (void)
 *
 ****************************************************************************/
static void _interrupt _far TXport (void)
{
int n;
int P;

_disable();
outp(0x20,0x20);

if (Intpls != 0)
  Intpls--;

if (Replay != 0)                   /* replay mode */
  goto Int_end;

if (Tune_count > 1)                /* tune runs */
  {
   Tune_count--;
   goto Receive;
   }

if (Tune_count == 1)               /* tune end */
  {
   Tune_count--;
   Setport(1);
   goto Receive;
  }

if (TX_on == 1)                               /* HellTX mode */
  {
   if (Hellfont[Tkvalue][0] == 0)  /* non defined character, extra safety */
     Tkvalue = 0;

   Hellchar = Hellfont[Tkvalue][Symbolcnt];

   if (Pixelcnt == Pixels)
     {
      if (Hellchar == '0')
	Setport(1);
      if (Hellchar == '1')
	Setport(1);
      if (Hellchar == '2')
	Setport(2);
      if (Hellchar == '3')
	Setport(2);
     }

   if (Pixelcnt == Halfpixels)
     {
      if (Hellchar == '1')
	Setport(2);
      if (Hellchar == '2')
	Setport(1);
     }

   Pixelcnt--;

   if (Pixelcnt == 0)
     {
      Pixelcnt = Pixels;

      Dble_widthcnt--;

      if (Dble_width == 1 && Dble_widthcnt == 7)
	Symbolcnt -= 7;                    /* repeat last 7 symbols */

      if (Dble_widthcnt == 0)
	Dble_widthcnt = 14;

      Symbolcnt++;

      if (Hellfont[Tkvalue][Symbolcnt] == 'E')
	{
	 Symbolcnt = 0;

	 if (Tkvalue > 1)                   /* add characterspace */
	   Tkvalue = 1;
	 else
	   {
	    Tkvalue = Inputbuf[0];
	    n = 0;
	    while (Inputbuf[n] != 0)
	      {
	       Inputbuf[n] = Inputbuf[n+1];
	       n++;
	      }
	    New_buffer = 1;

	    if (Input_count > 0)
	      Input_count--;

	    if (Hellfont[Tkvalue][0] == 0)  /* No defined character */
	      Tkvalue = 0;
	    if (Tkvalue != 0)
	      Stat_Hchar++;
	   }
	}
     }

  if (Tkvalue > 0)    /* pixel part of character */
    {
     Stat_pixel++;

     if (POORT == 1)
       Stat_pixelon++;
    }
  }


if (TX_on == 2)                    /* MorseTX mode */
  {
   if (Tkvalue == 0)               /* volgend karakter */
     {
      Tkvalue = MORSEkar[Inputbuf[0]];
      if (Tkvalue != 0)
	{
	 Stat_CWchar++;
	}
      else
	{
	 n = 0;
	 while (Inputbuf[n] != 0)
	   {
	    Inputbuf[n] = Inputbuf[n+1];
	    n++;
	   }
	 New_buffer = 1;

	 if (Input_count > 0)
	   Input_count--;
	}
     }

   if (Tkvalue == 0)
     goto Receive;

   Stat_CW++;
   if (POORT == 1)
     Stat_CWon++;

   if (Interrupt_count != 0)       /* wacht tot teken afgelopen is */
     {
      Interrupt_count--;
      goto Receive;
     }

   if (Tkvalue == 0xff)            /* woordspatie = tekenspatie + SPlng */
     {
      Interrupt_count = SPlng;
      Tkvalue = 1;                 /* 1 om volgend karakter te krijgen */
      goto Receive;
     }

   if (POORT == 1)                 /* tekenspatie = punt */
     {
      Setport(1);
      Interrupt_count = Puntlng;
      goto Receive;
     }

   if (Tkvalue > 1 && POORT == 0)
     {
      Setport(2);
      if (Tkvalue & 1)
	Interrupt_count = Streeplng;
      else
	Interrupt_count = Puntlng;

      Tkvalue >>= 1;
      goto Receive;
     }

   if (Tkvalue == 1)               /* karakterspatie = streep */
     {
      Tkvalue = 0;
      Interrupt_count = SPlng;

      n = 0;
      while (Inputbuf[n] != 0)
	{
	 Inputbuf[n] = Inputbuf[n+1];
	 n++;
	}
      New_buffer = 1;

      if (Input_count > 0)
	Input_count--;
     }
  }


/* Receive Hell routine */


Receive:

if (TX_on != 0)
  {
   if (TXRXstate == 0)
     goto Int_end;

   if (TXRXstate == 1)
     {
      P = 0;
      if (POORT == 1)
	P = 4096;
      goto Store_RXdta;
     }
  }

if (Detector == 0)
  {
   P = inp(LPT1);
   P ^= 0xffff;
   P &= DTABIT;

   if (P != 0)
     P = 4096;
  }

if (Detector == 1)
  {
   _asm
       {
	mov dx,LPT
	xor ax,ax
	in ax,dx
	and ax,0x7f     /* bit 7 =0, start opladen C */
	out dx,ax
	mov al,0x04
	out 0x43,al
	in al,0x40
	xchg ah,al
	in al,0x40
	xchg ah,al
	mov AD_start,ax
       }

   AD_timeout = AD_start - AD_offset - 255;

   _asm
       {
	mov dx,LPT1

	ADloop:
	mov al,0x04
	out 0x43,al
	in al,0x40
	xchg ah,al
	in al,0x40
	xchg ah,al
	mov AD_stop,ax
	cmp ax,AD_timeout
	jb ADend

	xor ax,ax

	in ax,dx
	and ax,DTABIT
	jnz ADloop

	ADend:
	mov dx,LPT
	xor ax,ax
	in ax,dx
	or ax,0x80    /* bit 7 =1, start ontladen C */
	out dx,ax
       }

   P = AD_start - AD_stop;
  }

Store_RXdta:

Pixeltube[Tube_intcnt] = P;
Tube_intcnt++;
Tube_intcnt &= 255;
Pixeltube[Tube_intcnt] = 0xffff;


Int_end:

_enable();
return;
}


/****************************************************************************
 *
 * void Setport(int Waarde) Zet de outputpoort 0: RX 1: TX_STBY 2: TX
 *
 ****************************************************************************/
void Setport(int Waarde)
{
 int p;

 if (Waarde == 0)
   {
    p = inp(97);
    p &= 252;
    outp(97,p);             /* toon uit */
    outp(LPT,RXport);       /* RX mode */
    POORT = 0;
   }

 if (Waarde == 1)
   {
    p = inp(97);
    p &= 252;
    outp(97,p);             /* toon uit */
    outp(LPT,TXport_stby);  /* TX STBY */
    POORT = 0;
   }

 if (Waarde == 2)
   {
    if (Tone_on != 0)
      {
       p = inp(97);
       p |= 3;
       outp(97,p);          /* toon aan */
      }
    outp(LPT,TXport_tone);  /* TX on */
    POORT = 1;
   }
}



/****************************************************************************
 *
 * void Fixlengte(char *da, char k, int le) vult da met char k aan tot le
 *
 ****************************************************************************/
void Fixlengte(char *da, char k, int le)
{
char txt[32];

if ((le > 30) || k < 32)
  return;

while (strlen(da) < le)
   {
    strcpy(txt,da);
    da[0] = k;
    da[1] = 0;
    strcat(da,txt);
   }
}


/****************************************************************************
 *
 * void Kloktijd(void) Real time klok inlezen in KLOK[]
 *
 ****************************************************************************/
void Kloktijd(void)
{
char kx[10];
int eeuw;
int seconde;

_asm
  {
   mov ah,0x04
   int 0x1a
   xor ax,ax
   mov al,cl
   mov JAAR,ax
   mov al,ch
   mov eeuw,ax
   mov al,dl
   mov DAG,ax
   mov al,dh
   mov MAAND,ax

   mov ah,0x02
   int 0x1a
   xor ax,ax
   mov al,cl
   mov MINUUT,ax
   mov al,ch
   mov UUR,ax
   mov al,dh
   mov seconde,ax
  }

JAAR = Klokhexdec(JAAR);
eeuw = Klokhexdec(eeuw);
DAG = Klokhexdec(DAG);
MAAND = Klokhexdec(MAAND);
MINUUT = Klokhexdec(MINUUT);
UUR = Klokhexdec(UUR);
seconde = Klokhexdec(seconde);

JAAR = 100 * eeuw + JAAR;

sprintf(kx,"%u",UUR);
Fixlengte(kx, '0', 2);
strcat(kx,":");
strcpy(KLOK,kx);

sprintf(kx,"%u",MINUUT);
Fixlengte(kx, '0', 2);
strcat(kx,":");
strcat(KLOK,kx);

sprintf(kx,"%u",seconde);
Fixlengte(kx, '0', 2);
strcat(kx,"  ");
strcat(KLOK,kx);

sprintf(kx,"%u",DAG);
Fixlengte(kx, '0', 2);
strcat(kx,"-");
strcat(KLOK,kx);

sprintf(kx,"%u",MAAND);
Fixlengte(kx, '0', 2);
strcat(kx,"-");
strcat(KLOK,kx);

sprintf(kx,"%u",JAAR);
Fixlengte(kx, '0', 2);
strcat(KLOK,kx);
}





/****************************************************************************
 *
 * int Klokhexdec(int hex) Real time klok format to decimal value conversion
 *
 ****************************************************************************/
int Klokhexdec(int hex)
{
int value;

value = 0;

while (hex >= 16)
  {
   hex -= 16;
   value += 10;
  }
value += hex;

return(value);
}



/****************************************************************************
 *
 * int Klokdechex(int dec) decimal to Real time klok format
 *
 ****************************************************************************/
int Klokdechex(int dec)
{
int value;

value = 0;

while (dec >= 10)
  {
   dec -= 10;
   value += 16;
  }
value += dec;

return(value);
}




/****************************************************************************
 *
 * void Uitleg(void) bedieningshandleiding en uitleg
 *
 ****************************************************************************/
void Uitleg(void)
{
Scherm(25);
_displaycursor(_GCURSOROFF);
window(1,1,24,80);

Print(2,3,"SHORT EXPLANATION (1/3):");
Print(3,3,"=========================");

Print(5,3,"This is a Feldhell transmit/receive DOS program and uses the original");
Print(6,3,"Feldhell font. The detector is a simple A/D converter, so that the");
Print(7,3,"received signals are displayed in grey scales, depending on the signal");
Print(8,3,"strength of the received signal.");
Print(9,3,"The A/D converter is connected to the LPT1 printerport.");
Print(10,3,"However, it is also possible to use a LA0BX on/off detector by setting");
Print(11,3,"Detector = 0 in the HELL01.INI file. Only black white is displayed then.");
Print(12,3,"Various settings are possible by editing the HELL01.INI file.");
Print(13,3,"The HELL01.INI should be saved in the same directory as this program.");
Print(14,3,"Before starting the program, change the workdirectory to the one that");
Print(15,3,"contains the files HELL01.INI file and HELL01.EXE. Type HELL01 to start.");
Print(16,3,"The LPT1 output is connected to the A/D converter and via a switching");
Print(17,3,"transistor connected to the key input of the CW transmitter.");
Print(18,3,"D7 (pin 9) is used to control the A/D converter.");
Print(19,3,"Pin numbers (D7 - D0): 98765432:");
Print(20,3,"        RX             X1111001");
Print(21,3,"        TX standby     X1110101");
Print(22,3,"        TX carrier     X1110110");
Print(23,3,"PRESS ANY KEY TO CONTINUE");

do
 {
  inkey();
 }
while (keyvalue == 0);

Scherm(25);
_displaycursor(_GCURSOROFF);
window(1,1,24,80);

Print(2,3,"SHORT EXPLANATION (2/3):");
Print(3,3,"=========================");

Print(5,3,"If the program does not work correctly, delete the file HELL01.INI and");
Print(6,3,"start the program. When you exit the program, HELL01.INI is saved with");
Print(7,3,"default values. Then edit the HELL01.INI file for your preferred settings.");
Print(8,3,"Keys: HOME to clear the buffer. CURSOR UP/DOWN to change the CW speed.");
Print(9,3,"PAGE UP / PAGE DOWN for statistics, F11, F12 for storing received data.");
Print(10,3,"Statistics show the TX-on / TX off ratio for the typed characters but");
Print(11,3,"waiting time (no input character) is excluded from the calculation.");
Print(12,3,"Finish the program by pressing ESC.");
Print(13,3,"Explanation of function key F10:");
Print(14,3,"Select HELL detection during transmit: Internal PC data or the detector");
Print(15,3,"used during reception or stop detection of HELL signals during transmit.");
Print(16,3,"If the A/D converter is connected to a separate receiver, you can receive");
Print(17,3,"your own transmitted HELL signal to check your transmission.");

Print(23,3,"PRESS ANY KEY TO CONTINUE");

do
 {
  inkey();
 }
while (keyvalue == 0);

Scherm(25);
_displaycursor(_GCURSOROFF);
window(1,1,24,80);

Print(2,3,"SHORT EXPLANATION (3/3):");
Print(3,3,"=========================");


Print(5,3,"Pre Programmed messages:");
Print(6,3,"Keys ALT+0....9 are pre programmed messages.");
Print(7,3,"These messages are made by using an ascii text editor and are in the same");
Print(8,3,"directory as the program.");
Print(9,3,"Names: HELLMSG0.TXT, HELLMSG1.TXT, ......, HELLMSG9.TXT.");
Print(11,3,"Replay: Use F11 and F12 keys, see for details the replay menue.");

Print(13,3,"At the end of the program, various settings are stored in the HELL01.INI");
Print(14,3,"file. If this file does not exist, standard settings are used.");
Print(15,3,"The program runs only under DOS and it uses the time interrupt.");

Print(23,3,"PRESS ANY KEY TO CONTINUE");

do
 {
  inkey();
 }
while (keyvalue == 0);
}






/************************************************************************/




/****************************************************************************
 *
 * void Hline(int r1, c1, c2) maakt horizontale window line
 *
 ****************************************************************************/

void Hline(int r1, int c1, int c2)
{
int n;
char line[2];

line[1] = 0;
line[0] = 204;
Print(r1,c1,line);

line[0] = 185;
Print(r1,c2,line);

line[0] = 205;

for (n = c1 + 1;n < c2;n++)
   {
    Print(r1,n,line);
   }
}



/****************************************************************************
 *
 * void inkey(void) geeft in extern int keyvalue het ingedrukt karakter
 *
 ****************************************************************************/
void inkey(void)
{
  unsigned char key[3];

  key[0] = 0;
  keyvalue = 0;
  if (kbhit())
  {
     key[0] = getch();
     keyvalue = (int)key[0];

     if (key[0] == 0)
	{
	 key[0] = getch();
	 keyvalue = (int)key[0];
	 keyvalue += 128;
	}
  }
}


/****************************************************************************
 *
 * void In_ntext(int yp,int xp,int maxlen, *k) alleen numeriek
 *
 ****************************************************************************/
void In_ntext(int yp,int xp,int maxlen,char *k)
{
int cnt = 0;
int accept=0;
k[cnt] = 0;


do
  {
   accept = 0;

   if (cnt < 0)
     cnt = 0;

   if (xp < 3)
     xp = 3;

   if (xp > 78)
     xp = 78;

   _settextposition(yp,xp);

   inkey();

   if (keyvalue == 27)
     {
      k[0] = 27;
      cnt = 1;
      break;
     }

   if (keyvalue == 8)
     {
      k[cnt] = 0;
      if (cnt > 0)
	{
	 cnt--;
	 xp--;
	}

      if (xp < 3)
	{
	 xp = 78;
	 yp--;
	}

      Print(yp,xp," ");
     }

  if (keyvalue == (int)'.')
     accept = 1;

  if (cnt == 0 && keyvalue == (int)'+')
     accept = 1;

  if (cnt == 0 && keyvalue == (int)'-')
     accept = 1;

  if (keyvalue >= (int)'0' && keyvalue <= (int)'9')
     accept = 1;

  if (accept != 0)
    {
     accept = 0;

     if (cnt < maxlen)
       {
	k[cnt] = (char)keyvalue;
	k[cnt + 1] = 0;
	Print(yp,xp,&k[cnt]);

	cnt++;
	xp++;
       }

     if (cnt == maxlen)
       {
	Print(yp,xp," ");
       }

     if (xp > 78)
       {
	xp = 3;
	yp++;
       }
    }

}
while (keyvalue != 13);

k[cnt] = 0;

}


/****************************************************************************
 *
 * void In_utext(int yp,int xp,int maxlen, *k) maakt van kleine hoofdletters
 *
 ****************************************************************************/
void In_utext(int yp,int xp,int maxlen,char *k)
{
int cnt = 0;

k[cnt] = 0;


do
  {
   if (cnt < 0)
     cnt = 0;

   if (xp < 3)
     xp = 3;

   if (xp > 78)
     xp = 78;

   _settextposition(yp,xp);

   inkey();

   if (keyvalue == 27)
     {
      k[0] = 27;
      cnt = 1;
      break;
     }

   if (keyvalue == 8)
     {
      k[cnt] = 0;
      if (cnt > 0)
	{
	 cnt--;
	 xp--;
	}

      if (xp < 3)
	{
	 xp = 78;
	 yp--;
	}

      _settextposition(yp,xp);
      _outtext(" ");
     }

  if (keyvalue >= 'a' && keyvalue <= 'z')
    keyvalue -= 32;

  if (keyvalue >= (int)' ' && keyvalue <= (int)'Z')
    {
     if (cnt < maxlen)
       {
	k[cnt] = (char)keyvalue;
	k[cnt + 1] = 0;
	_settextposition(yp,xp);
	_outtext(&k[cnt]);

	cnt++;
	xp++;
       }

     if (cnt == maxlen)
       {
	_settextposition(yp,xp);
	_outtext(" ");
       }

     if (xp > 78)
       {
	xp = 3;
	yp++;
       }
    }
}
while (keyvalue != 13);

k[cnt] = 0;

}





/****************************************************************************
 *
 * void pauze (float p) geeft pauze van p seconden
 *
 ****************************************************************************/
void pauze(float p)
{
 double tijd1,tijd2;
 struct timeb tm;
 ftime(&tm);
 tijd1 = tm.time + (double)tm.millitm / 1000 + p;

 do
   {
    ftime(&tm);
    tijd2 = tm.time + (double)tm.millitm / 1000;
   }
 while(tijd2 < tijd1);
}



/****************************************************************************
 *
 * void Print(int y, int x, char *tekst   print tekst op y, x
 *
 ****************************************************************************/
void Print(int y, int x, char *tekst)
{
x--;   /* correctie van 1 naar 0 */
y--;

_asm
    {
     xor ax,ax;
     mov ah,2;
     xor bx,bx;
     mov dh,y;
     mov dl,x;
     int 0x10;
    }
printf(tekst);       /* let op geen _outtext! */
}



/****************************************************************************
 *
 * void Scherm(int lijnen) stelt scherm in
 *
 ****************************************************************************/

void Scherm(int lijnen)
{
_asm               /* set simple screenmode */
  {
   mov ax,3;       /* ah = 0 */
   int 0x10;
  }

_settextrows(lijnen);
_displaycursor(_GCURSORON);
_settextcursor(0x0607);
_setbkcolor((long)schermkleur);
_settextcolor(tekstkleur);
_clearscreen(_GWINDOW);
}





/****************************************************************************
 *
 * void Vline(int r1, c1, r2) maakt verticale window line
 *
 ****************************************************************************/

void Vline(int r1, int c1, int r2)
{
int n;
char line[2];

line[1] = 0;
line[0] = 203;
Print(r1,c1,line);

line[0] = 202;
Print(r2,c1,line);

line[0] = 186;

for (n = r1 + 1;n < r2;n++)
   {
    Print(n,c1,line);
   }
}




/****************************************************************************
 *
 * void window(int r1, c1, r2, c2) maakt window
 *
 ****************************************************************************/

void window(int r1, int c1, int r2, int c2)
{
int n;
char line[2];

line[1] = 0;
line[0] = 201;
Print(r1,c1,line);

line[0] = 187;
Print(r1,c2,line);

line[0] = 200;
Print(r2,c1,line);

line[0] = 188;
Print(r2,c2,line);

line[0] = 205;

for (n = c1 + 1;n < c2;n++)
   {
    Print(r1,n,line);
   }

for (n = c1 + 1;n < c2;n++)
   {
    Print(r2,n,line);
   }

line[0] = 186;

for (n = r1 + 1;n < r2;n++)
   {
    Print(n,c1,line);
   }

for (n = r1 + 1;n < r2;n++)
   {
    Print(n,c2,line);
   }

}

